#!/bin/sh
# ActX version 0.99 : Auto-Configuration Script

VERSION="0.99.3"
PATH=.:$PATH
  
DEFAULT_CC="cc"
DEFAULT_I18N="y"
DEFAULT_KINDAW="1"
DEFAULT_BINDIR=$HOME/bin
DEFAULT_MASCOTDIR=$HOME/lib/ActX
DEFAULT_VOODOO="n"

IMAKE_FILE="./Imakefile"
RC_FILE="./install.actxrc"

echo "This is the install configuration for ActX version$VERSION."
echo ""
echo "Please answer following some questions."
echo " The values inside of [ ] are default ones."
echo "  If you hit CR without any letters, I select these ones."
echo ""

if [ "$HOME" = "/root" ] ; then
    echo ""
    echo "!!!!! WARNING! WARNING! WARNING! WARNING! WARNING! WARNING! !!!!!"
    echo "  This script is operated by root-user."
    echo "  This script is installing config file [.actxrc] to the operating user's Home Directry."
    echo "  So, I recommend you to use your usual account."

ROOT_FLAG=""
while [ "$ROOT_FLAG" = "" ]
do
    echo "Continue? (y/[n]) :" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT="n"
    fi
    if [ "$INPUT" = "n" ] ; then
	ROOT_FLAG="exit"
	exit
    fi
    if [ "$INPUT" = "y" ] ; then
	ROOT_FLAG="go"
	echo "... to the next step ..."
    fi
done
fi

I18N=""
while [ "$I18N" = "" ]
do
    echo ""
    echo "Do you support i18n (for Japanese)? ([y]/n) :" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT=$DEFAULT_I18N
    fi
    if [ "$INPUT" = "n" ] ; then
	echo "#undef USE_I18N"  > $IMAKE_FILE
	I18N="n"
    fi
    if [ "$INPUT" = "y" ] ; then
	echo "#define USE_I18N" > $IMAKE_FILE
	I18N="y"
    fi
	RC_SAMPLE="./build/actxrc"
done
	echo ""                 >> $IMAKE_FILE


VOODOO=""
while [ "$VOODOO" = "" ]
do
    echo ""
    echo "Are you using Voodoo3 or Banshee for XFree86 3.3.5 before? (y/[n]) :" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT=$DEFAULT_VOODOO
    fi
    if [ "$INPUT" = "n" ] ; then
	echo "#undef USE_VOODOO"  >> $IMAKE_FILE
	VOODOO="n"
    fi
    if [ "$INPUT" = "y" ] ; then
	echo "#define USE_VOODOO" >> $IMAKE_FILE
	echo "###########################################################################"
	echo " There are some serious bugs in the Voodoo engine of XFree86 3.3.5 before."
	echo " To avoid this bugs, the drag motion of mascots will be forbidden."
	echo "###########################################################################"
	echo ""
	VOODOO="y"
    fi
done
	echo ""                 >> $IMAKE_FILE


KINDAW=""
while [ "$KINDAW" = "" ]
do
    echo ""
    echo "Which Athena Widget do you use?"
    echo " ================================"
    echo " 1. normal athena widget (libXaw)"
    echo " 2. Xaw3d"
    echo " 3. neXtaw"
    echo " ================================"
    echo "  (If you do not understand, just hit CR.) (1-3 [1]):" ; read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT=$DEFAULT_KINDAW
    fi
    if [ "$INPUT" = "1" ] ; then
	echo "#undef NEXTAW" >> $IMAKE_FILE
	echo "#undef XAW3D" >> $IMAKE_FILE
	echo ""
	KINDAW="1"
    fi
    if [ "$INPUT" = "2" ] ; then
	echo "#undef NEXTAW" >> $IMAKE_FILE
	echo "#define XAW3D" >> $IMAKE_FILE
	echo ""
	echo "  Now using Xaw3d ..."
	echo "  Please confirm that header files for Xaw3d have been installed in /usr/include/X11/Xaw3d."
	echo ""
	KINDAW="2"
    fi
    if [ "$INPUT" = "3" ] ; then
	echo "#define NEXTAW" >> $IMAKE_FILE
	echo "#undef XAW3D" >> $IMAKE_FILE
	echo ""
	echo "  Now using neXtaw ..."
	echo "  Please confirm that header files for neXtaw have been installed in /usr/include/X11/neXtaw."
	echo ""
	KINDAW="3"
    fi
done
    echo ""                >> $IMAKE_FILE


echo ""
echo "Where should ActX-binary be installed?  [$DEFAULT_BINDIR] :"

read INPUT
if [ "$INPUT" = "" ] ; then
    INPUT=$DEFAULT_BINDIR
fi
BINDIR=$INPUT

echo "BINDIR = $BINDIR" >> $IMAKE_FILE
echo ""                 >> $IMAKE_FILE

echo "  ... ActX bainary is installing to $BINDIR."
echo ""


echo ""
echo "Where should mascot data (.xpm) be installed?  [$DEFAULT_MASCOTDIR] :"

read INPUT
if [ "$INPUT" = "" ] ; then
    INPUT=$DEFAULT_MASCOTDIR
fi
MASCOTDIR=$INPUT

echo "#define MASCOTDIR $MASCOTDIR" >> $IMAKE_FILE
echo ""                             >> $IMAKE_FILE

cp -f $RC_SAMPLE.1 $RC_FILE
echo "Actx*xpmDir: $MASCOTDIR" >> $RC_FILE
cat $RC_SAMPLE.2               >> $RC_FILE

echo "   ... Mascot data are installing to $MASCOTDIR."
echo ""

echo "DEFINES_MASCOTDIR = -DMASCOTDIR=\\\"$MASCOTDIR\\\"" >> $IMAKE_FILE
echo ""                             >> $IMAKE_FILE


CC=""
echo ""
echo "Which compiler will you use?  [$DEFAULT_CC] :" ; read INPUT
if [ "$INPUT" = "" ] ; then
    INPUT=$DEFAULT_CC
fi
CC=$INPUT

echo "CC = $CC" >> $IMAKE_FILE
echo ""         >> $IMAKE_FILE


cat ./build/Imakefile.1 >> $IMAKE_FILE


echo "Now installing the config file $HOME/.actxrc."

if [ -f $HOME/.actxrc ] ; then
    echo " $HOME/.actxrc already exists. Overwirte? (y/[n]) :"
    echo "   (The existing file will be back-uped to $HOME/.actxrc-backup.)"
    
    
    read INPUT
    if [ "$INPUT" = "" ] ; then
	INPUT="n"
    fi
    if [ "$INPUT" = "y" ] ; then
	cp -f $HOME/.actxrc $HOME/.actxrc-backup
	cp -f $RC_FILE $HOME/.actxrc
	echo " $HOME/.actxrc is installed."
    else
	echo " $HOME/.actxrc is not installed."
	echo " Please confirm your configuration in $HOME/.actxrc."
    fi
else
    cp -f $RC_FILE $HOME/.actxrc
    echo " $HOME/.actxrc is installed."
fi

echo ""


echo "Now, configuration is finished."
echo "Please confirm built Imakefile, and use following commands"
echo "======================================="
echo "     xmkmf"
echo "     make"
echo "     su (if needed)"
echo "     make install"
echo "======================================="
echo ""

if [ "$I18N" = "y" ] ; then
    echo "To support i18n, please add this line to your $HOME/.Xdefaults etc."
    echo "   Actx*international:true"
    echo ""
fi





